diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/ginclude/stdarg.h gcc-3.4.4-3/gcc/ginclude/stdarg.h
--- gcc-3.4.4-3-orig/gcc/ginclude/stdarg.h	2003-03-13 02:58:40.000000000 +0000
+++ gcc-3.4.4-3/gcc/ginclude/stdarg.h	2005-06-03 21:03:38.000000000 +0100
@@ -30,6 +30,7 @@
 
 #ifndef _STDARG_H
 #ifndef _ANSI_STDARG_H_
+#ifndef RC_INVOKED
 #ifndef __need___va_list
 #define _STDARG_H
 #define _ANSI_STDARG_H_
@@ -129,5 +130,6 @@
 
 #endif /* _STDARG_H */
 
+#endif /* not RC_INVOKED */
 #endif /* not _ANSI_STDARG_H_ */
 #endif /* not _STDARG_H */
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/hwint.h gcc-3.4.4-3/gcc/hwint.h
--- gcc-3.4.4-3-orig/gcc/hwint.h	2003-06-25 20:33:08.000000000 +0100
+++ gcc-3.4.4-3/gcc/hwint.h	2005-06-03 21:03:34.000000000 +0100
@@ -15,6 +15,12 @@
 #define HOST_BITS_PER_INT   (CHAR_BIT * SIZEOF_INT)
 #define HOST_BITS_PER_LONG  (CHAR_BIT * SIZEOF_LONG)
 
+/* On some hosts, runtime printf does not use standard long long prefix.
+   This default can be overriden in host config file.  */
+#ifndef HOST_LL_PREFIX
+# define HOST_LL_PREFIX "ll"
+#endif
+
 /* If HAVE_LONG_LONG and SIZEOF_LONG_LONG aren't defined, but
    GCC_VERSION >= 3000, assume this is the second or later stage of a
    bootstrap, we do have long long, and it's 64 bits.  (This is
@@ -74,10 +80,10 @@
 #  define HOST_WIDE_INT_PRINT_DOUBLE_HEX "0x%lx%08lx"
 # endif
 #else
-# define HOST_WIDE_INT_PRINT "ll"
+# define HOST_WIDE_INT_PRINT HOST_LL_PREFIX
 # define HOST_WIDE_INT_PRINT_C "LL"
   /* We can assume that 'long long' is at least 64 bits.  */
-# define HOST_WIDE_INT_PRINT_DOUBLE_HEX "0x%llx%016llx"
+# define HOST_WIDE_INT_PRINT_DOUBLE_HEX "0x%" HOST_LL_PREFIX "x%016" HOST_LL_PREFIX "x"
 #endif /* HOST_BITS_PER_WIDE_INT == HOST_BITS_PER_LONG */
 
 #define HOST_WIDE_INT_PRINT_DEC "%" HOST_WIDE_INT_PRINT "d"
@@ -109,11 +115,11 @@
     #error "This line should be impossible to reach"
 #  endif
 # endif
-# define HOST_WIDEST_INT_PRINT_DEC	      "%lld"
-# define HOST_WIDEST_INT_PRINT_DEC_C	      "%lldLL"
-# define HOST_WIDEST_INT_PRINT_UNSIGNED	      "%llu"
-# define HOST_WIDEST_INT_PRINT_HEX	      "0x%llx"
-# define HOST_WIDEST_INT_PRINT_DOUBLE_HEX     "0x%llx%016llx"
+# define HOST_WIDEST_INT_PRINT_DEC	      "%" HOST_LL_PREFIX "d"
+# define HOST_WIDEST_INT_PRINT_DEC_C	      "%" HOST_LL_PREFIX "dLL"
+# define HOST_WIDEST_INT_PRINT_UNSIGNED	      "%" HOST_LL_PREFIX "u"
+# define HOST_WIDEST_INT_PRINT_HEX	      "0x%" HOST_LL_PREFIX "x"
+# define HOST_WIDEST_INT_PRINT_DOUBLE_HEX     "0x%" HOST_LL_PREFIX "x%016" HOST_LL_PREFIX "x"
 #endif
 
 #endif /* ! GCC_HWINT_H */
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/integrate.c gcc-3.4.4-3/gcc/integrate.c
--- gcc-3.4.4-3-orig/gcc/integrate.c	2004-12-05 05:21:02.000000000 +0000
+++ gcc-3.4.4-3/gcc/integrate.c	2006-05-17 02:44:58.000000000 +0100
@@ -1341,6 +1341,30 @@
     {
       rtx copy, pattern, set;
 
+#ifdef GPC
+      /* CALL_PLACEHOLDERs within inline functions seem to cause
+         trouble in Pascal (fjf709.pas). References to formal
+         parameters of the inline function might get confused. So
+         replace the CALL_PLACEHOLDER by the normal calling code
+         here, at the cost of avoiding this particular combination
+         of optimizations (inlining and tail recursion/sibling
+         calls) -- though I'm not actually sure if it should be done
+         at all; the C frontend also seems to do only inlining in a
+         similar situation, and this might be good enough already.
+
+         I don't understand all the backend does here, and I'm not
+         even sure if the real bug is in the fontend or backend, or
+         whether this is a fix or a work-around ... -- Frank */
+      if (GET_CODE (insn) == CALL_INSN
+          && GET_CODE (PATTERN (insn)) == CALL_PLACEHOLDER)
+        {
+          rtx tmp = PREV_INSN (insn);
+          replace_call_placeholder (insn, sibcall_use_normal);
+          insn = tmp;
+          continue;
+        }
+#endif
+
       map->orig_asm_operands_vector = 0;
 
       switch (GET_CODE (insn))
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/java/expr.c gcc-3.4.4-3/gcc/java/expr.c
--- gcc-3.4.4-3-orig/gcc/java/expr.c	2004-01-30 01:31:32.000000000 +0000
+++ gcc-3.4.4-3/gcc/java/expr.c	2005-06-03 21:03:38.000000000 +0100
@@ -2201,7 +2201,7 @@
   args = NULL_TREE;
   for (tem = method_args; tem != NULL_TREE; tem = TREE_CHAIN (tem))
     {
-      int arg_bits = TREE_INT_CST_LOW (TYPE_SIZE_UNIT (TREE_TYPE (tem)));
+      int arg_bits = TREE_INT_CST_LOW (TYPE_SIZE (TREE_TYPE (tem)));
 #ifdef PARM_BOUNDARY
       arg_bits = (((arg_bits + PARM_BOUNDARY - 1) / PARM_BOUNDARY)
                   * PARM_BOUNDARY);
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/java/parse.y gcc-3.4.4-3/gcc/java/parse.y
--- gcc-3.4.4-3-orig/gcc/java/parse.y	2004-12-08 17:29:40.000000000 +0000
+++ gcc-3.4.4-3/gcc/java/parse.y	2005-06-03 21:03:38.000000000 +0100
@@ -13853,8 +13853,7 @@
       /* OP1 is no longer the last node holding a crafted StringBuffer */
       IS_CRAFTED_STRING_BUFFER_P (op1) = 0;
       /* Create a node for `{new...,xxx}.append (op2)' */
-      if (op2)
-	op1 = make_qualified_primary (op1, BUILD_APPEND (op2), 0);
+      op1 = make_qualified_primary (op1, BUILD_APPEND (op2), 0);
     }
 
   /* Mark the last node holding a crafted StringBuffer */
@@ -15827,8 +15826,10 @@
   tree t1, t2, patched;
   int error_found = 0;
 
-  /* Operands of ?: might be StringBuffers crafted as a result of a
-     string concatenation. Obtain a descent operand here.  */
+  /* The condition and operands of ?: might be StringBuffers crafted
+     as a result of a string concatenation.  Obtain decent ones here.  */
+  if ((patched = patch_string (cond)))
+    TREE_OPERAND (node, 0) = cond = patched;
   if ((patched = patch_string (op1)))
     TREE_OPERAND (node, 1) = op1 = patched;
   if ((patched = patch_string (op2)))
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/libgcc2.c gcc-3.4.4-3/gcc/libgcc2.c
--- gcc-3.4.4-3-orig/gcc/libgcc2.c	2004-12-15 12:34:24.000000000 +0000
+++ gcc-3.4.4-3/gcc/libgcc2.c	2005-06-03 23:16:56.000000000 +0100
@@ -29,6 +29,17 @@
 Software Foundation, 59 Temple Place - Suite 330, Boston, MA
 02111-1307, USA.  */
 
+#ifdef L_eprintf
+#ifdef __APPLE__
+/* Hack for MacOS 10.4: gcc 3.4.x uses -mlong-double-128 to build
+   libgcc.  On 10.4, this causes *printf to be defined as
+   *printf$LDBLStub and requires linking with libSystemStubs.  Prevent
+   this from happening by making it seem as though double is the same
+   as long double. */
+#undef  __LDBL_MANT_DIG__
+#define __LDBL_MANT_DIG__ __DBL_MANT_DIG__
+#endif
+#endif
 
 /* We include auto-host.h here to get HAVE_GAS_HIDDEN.  This is
    supposedly valid even though this is a "target" file.  */
@@ -1573,7 +1584,7 @@
 
 /* Jump to a trampoline, loading the static chain address.  */
 
-#if defined(WINNT) && ! defined(__CYGWIN__) && ! defined (_UWIN)
+#if defined(_WIN32) && ! defined(__CYGWIN__) && ! defined (_UWIN)
 
 long
 getpagesize (void)
@@ -1620,7 +1631,7 @@
 #endif
 #endif /* L_trampoline */
 
-#ifndef __CYGWIN__
+#if !(defined  __CYGWIN__ || defined __MINGW32__)
 #ifdef L__main
 
 #include "gbl-ctors.h"
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/p/gbe.h gcc-3.4.4-3/gcc/p/gbe.h
--- gcc-3.4.4-3-orig/gcc/p/gbe.h	2005-03-25 20:53:14.000000000 +0000
+++ gcc-3.4.4-3/gcc/p/gbe.h	2006-05-17 05:00:32.000000000 +0100
@@ -153,7 +153,11 @@
 extern struct function *outer_function_chain;
 #endif
 #else
+#if !defined(GCC_3_3) && !defined(GCC_3_4)
 extern char *version_string;
+#else
+extern const char version_string[];
+#endif
 extern char *progname;  /* in cpplib.h, but we don't need to include it just for that */
 extern struct obstack permanent_obstack;
 extern struct obstack *current_obstack;
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/p/gpc.c gcc-3.4.4-3/gcc/p/gpc.c
--- gcc-3.4.4-3-orig/gcc/p/gpc.c	2005-03-28 20:47:04.000000000 +0100
+++ gcc-3.4.4-3/gcc/p/gpc.c	2006-05-17 05:00:42.000000000 +0100
@@ -119,7 +119,12 @@
 #include "flags.h"
 #include "version.h"
 #else
+#if !defined(GCC_3_3) && !defined(GCC_3_4)
 extern char *version_string;
+#else
+extern const char version_string[];
+#endif
+
 extern char *make_temp_file (const char *);
 extern void *alloca (size_t);
 #endif
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/p/gpcpp.c gcc-3.4.4-3/gcc/p/gpcpp.c
--- gcc-3.4.4-3-orig/gcc/p/gpcpp.c	2005-03-20 12:15:30.000000000 +0000
+++ gcc-3.4.4-3/gcc/p/gpcpp.c	2006-05-17 05:00:48.000000000 +0100
@@ -108,7 +108,7 @@
 
 typedef unsigned char U_CHAR;
 
-#ifndef GCC_3_3
+#if !defined(GCC_3_3) && !defined(GCC_3_4)
 extern char *version_string;
 #else
 extern const char version_string[];
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/p/gpcspec.c gcc-3.4.4-3/gcc/p/gpcspec.c
--- gcc-3.4.4-3-orig/gcc/p/gpcspec.c	2005-03-20 12:15:30.000000000 +0000
+++ gcc-3.4.4-3/gcc/p/gpcspec.c	2006-05-17 05:00:56.000000000 +0100
@@ -98,7 +98,11 @@
 static int gpc_newargc;
 static char **gpc_newargv;
 
+#if !defined(GCC_3_3) && !defined(GCC_3_4)
 extern char *version_string;
+#else
+extern const char version_string[];
+#endif
 
 /* --- This comes from gcc.c (2.8.1) verbatim: */
 
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/p/options.c gcc-3.4.4-3/gcc/p/options.c
--- gcc-3.4.4-3-orig/gcc/p/options.c	2005-03-28 16:24:32.000000000 +0100
+++ gcc-3.4.4-3/gcc/p/options.c	2006-05-17 05:01:26.000000000 +0100
@@ -916,8 +916,10 @@
   if (version_flag)
     fprintf (stderr, "GNU Pascal version is actually %s, based on gcc-%s\n", GPC_RELEASE_STRING, version_string);
 #else
+#if !defined(GCC_3_3) && !defined(GCC_3_4)
   version_string = concat (GPC_RELEASE_STRING ", based on gcc-", version_string, NULL);
 #endif
+#endif
 
   lexer_options = compiler_options = co = (struct options *) xmalloc (sizeof (struct options));
   memset (co, 0, sizeof (struct options));
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/real.h gcc-3.4.4-3/gcc/real.h
--- gcc-3.4.4-3-orig/gcc/real.h	2003-10-10 21:33:06.000000000 +0100
+++ gcc-3.4.4-3/gcc/real.h	2006-05-13 17:35:34.000000000 +0100
@@ -40,9 +40,17 @@
 #define SIGSZ			(SIGNIFICAND_BITS / HOST_BITS_PER_LONG)
 #define SIG_MSB			((unsigned long)1 << (HOST_BITS_PER_LONG - 1))
 
+/* Can't have "class" in C++, but gentype gets confused on #ifdefs
+   within the struct. */
+#ifndef __cplusplus
+# define REAL_CLASSY class
+#else
+# define REAL_CLASSY cl
+#endif
+
 struct real_value GTY(())
 {
-  ENUM_BITFIELD (real_value_class) class : 2;
+  ENUM_BITFIELD (real_value_class) REAL_CLASSY : 2;
   unsigned int sign : 1;
   unsigned int signalling : 1;
   unsigned int canonical : 1;
@@ -50,6 +58,8 @@
   unsigned long sig[SIGSZ];
 };
 
+#undef REAL_CLASSY
+
 /* Various headers condition prototypes on #ifdef REAL_VALUE_TYPE, so it
    needs to be a macro.  We do need to continue to have a structure tag
    so that other headers can forward declare it.  */
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/rtl.h gcc-3.4.4-3/gcc/rtl.h
--- gcc-3.4.4-3-orig/gcc/rtl.h	2004-12-05 05:21:02.000000000 +0000
+++ gcc-3.4.4-3/gcc/rtl.h	2006-05-13 17:35:34.000000000 +0100
@@ -121,8 +121,13 @@
   int rtint;
   unsigned int rtuint;
   const char *rtstr;
+#ifndef __cplusplus
   rtx rtx;
   rtvec rtvec;
+#else
+  rtx rt_rtx;
+  rtvec rt_vec;
+#endif
   enum machine_mode rttype;
   addr_diff_vec_flags rt_addr_diff_vec_flags;
   struct cselib_val_struct *rt_cselib;
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/stor-layout.c gcc-3.4.4-3/gcc/stor-layout.c
--- gcc-3.4.4-3-orig/gcc/stor-layout.c	2004-05-29 00:16:00.000000000 +0100
+++ gcc-3.4.4-3/gcc/stor-layout.c	2006-05-17 02:44:58.000000000 +0100
@@ -1,6 +1,6 @@
 /* C-compiler utilities for types and variables storage layout
    Copyright (C) 1987, 1988, 1992, 1993, 1994, 1995, 1996, 1996, 1998,
-   1999, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.
+   1999, 2000, 2001, 2002, 2003. 2004  Free Software Foundation, Inc.
 
 This file is part of GCC.
 
@@ -20,6 +20,8 @@
 02111-1307, USA.  */
 
 
+/* @@ PATCHED FOR GPC 20050320 @@ */
+
 #include "config.h"
 #include "system.h"
 #include "coretypes.h"
@@ -59,6 +61,20 @@
    called only by a front end.  */
 static int reference_types_internal = 0;
 
+#ifdef GPC
+/* The word size of a bitstring or (power-)set value, in bits.
+   Must be non-zero.
+   May be overridden by front-ends.  */
+unsigned int set_word_size = BITS_PER_UNIT;
+
+/* If non-zero, bits in (power-)sets start with the highest bit.
+   May be overridden by front-ends.
+   In order to be backward-compatible, the Chill frontend should
+   initialize this to BYTES_BIG_ENDIAN.  */
+unsigned int set_words_big_endian = 0;
+
+#endif /* GPC */
+
 static void finalize_record_size (record_layout_info);
 static void finalize_type_size (tree);
 static void place_union_field (record_layout_info, tree);
@@ -1654,7 +1670,11 @@
 
 		if (maxvalue - minvalue == 1
 		    && (maxvalue == 1 || maxvalue == 0))
+#ifndef GPC
 		  element_size = integer_one_node;
+#else /* GPC */
+		  element_size = bitsize_int(1);
+#endif /* GPC */
 	      }
 
 	    /* If neither bound is a constant and sizetype is signed, make
@@ -1759,6 +1779,7 @@
 	abort ();
       else
 	{
+#ifndef GPC
 #ifndef SET_WORD_SIZE
 #define SET_WORD_SIZE BITS_PER_WORD
 #endif
@@ -1777,9 +1798,47 @@
 
 	  TYPE_SIZE (type) = bitsize_int (rounded_size);
 	  TYPE_SIZE_UNIT (type) = size_int (rounded_size / BITS_PER_UNIT);
+#else /* GPC */
+	  int alignment = set_alignment ? set_alignment : set_word_size;
+	  tree lower_bound = convert (sbitsizetype, 
+			TYPE_MIN_VALUE (TYPE_DOMAIN (type))); 
+	  tree upper_bound = convert (sbitsizetype,
+			TYPE_MAX_VALUE (TYPE_DOMAIN (type))); 
+	  tree size_in_bits, rounded_size;
+	  if (set_alignment)
+            {
+              lower_bound = round_down (lower_bound, alignment);
+            }
+	  size_in_bits = size_binop (PLUS_EXPR,
+				size_binop (MINUS_EXPR,
+					upper_bound,
+					lower_bound),
+				sbitsize_int(1));
+          rounded_size = round_up (size_in_bits, alignment);
+				
+	  if ( TREE_INT_CST_HIGH (rounded_size) 
+		|| TREE_INT_CST_LOW (rounded_size) > (unsigned) alignment) 
+	    {
+		TYPE_MODE (type) = BLKmode;
+	    }
+	  else 
+	    {
+		TYPE_MODE (type) = mode_for_size (alignment, MODE_INT, 1);
+	    } 
+
+	  TYPE_SIZE (type) = convert (bitsizetype, rounded_size);
+	  TYPE_SIZE_UNIT (type) = convert (sizetype, 
+				size_binop ( CEIL_DIV_EXPR,
+					rounded_size, 
+					sbitsize_int (BITS_PER_UNIT)));
+#endif /* GPC */
 	  TYPE_ALIGN (type) = alignment;
 	  TYPE_USER_ALIGN (type) = 0;
+#ifndef GPC
 	  TYPE_PRECISION (type) = size_in_bits;
+#else /* GPC */
+	  TYPE_PRECISION (type) = TREE_INT_CST_LOW (size_in_bits);
+#endif /* GPC */
 	}
       break;
 
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/testsuite/g++.dg/ext/attrib9.C gcc-3.4.4-3/gcc/testsuite/g++.dg/ext/attrib9.C
--- gcc-3.4.4-3-orig/gcc/testsuite/g++.dg/ext/attrib9.C	2004-01-14 07:31:40.000000000 +0000
+++ gcc-3.4.4-3/gcc/testsuite/g++.dg/ext/attrib9.C	2006-05-13 17:35:36.000000000 +0100
@@ -1,5 +1,5 @@
-class __attribute__((unused)) C;	//  { dg-warning "type attributes" }
-struct __attribute__((unused)) S;	//  { dg-warning "type attributes" }
-union __attribute__((unused)) U;	//  { dg-warning "type attributes" }
+class __attribute__((unused)) C;
+struct __attribute__((unused)) S;
+union __attribute__((unused)) U;
 enum e {};
-enum __attribute__((unused)) e;		//  { dg-warning "type attributes" }
+enum __attribute__((unused)) e;
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/testsuite/g++.dg/warn/weak1.C gcc-3.4.4-3/gcc/testsuite/g++.dg/warn/weak1.C
--- gcc-3.4.4-3-orig/gcc/testsuite/g++.dg/warn/weak1.C	2003-04-26 22:31:24.000000000 +0100
+++ gcc-3.4.4-3/gcc/testsuite/g++.dg/warn/weak1.C	2006-05-13 17:35:36.000000000 +0100
@@ -1,6 +1,6 @@
 // { dg-do run }
-// { dg-do compile { target *-*-coff i?86-pc-cygwin } }
-// { dg-warning "weak declaration" "COFF format does not support weak" { target *-*-coff i?86-pc-cygwin powerpc-ibm-aix4* rs6000-ibm-aix4* } 5 }
+// { dg-do compile { target *-*-coff i?86-pc-cygwin i?86-pc-mingw*} }
+// { dg-warning "weak declaration" "COFF format does not support weak" { target *-*-coff i?86-pc-cygwin i?86-pc-mingw* powerpc-ibm-aix4* rs6000-ibm-aix4* } 5 }
 
 extern void foo (void) __attribute__ ((weak));
 
diff -urdN -x .build -x .inst -x .sinst -x CVS -x MinGW -x '*.rej' -x '*.orig' -x .brik -x .cvsignore -x gcc-2.95.1.diff -x gcc-2.95.2.diff -x gcc-2.95.3-5.diff -x gcc-2.95.3-6.diff -x gcc-2.95.3-8.diff -x gcc-2.95.3.diff -x gcc-2.95.4.diff -x gcc-3.2.2.diff -x gcc-3.2.3.diff -x gcc-3.3.1.diff -x gm2-ebnf.texi -x gm2.info -x gm2.info-1 -x gm2.info-2 -x gnat_ug_unx.info -x gnat_ug_unx.texi -x gnat_ug_unx.info-1 -x gnat_ug_unx.info-2 -x gnat_ug_unx.info-3 -x gnat_ug_vms.info -x gnat_ug_vms.texi -x gnat_ug_vms.info-1 -x gnat_ug_vms.info-2 -x gnat_ug_vms.info-3 -x gnat_ug_vxw.info -x gnat_ug_vxw.texi -x gnat_ug_vxw.info-1 -x gnat_ug_vxw.info-2 -x gnat_ug_vxw.info-3 -x gnat_ug_wnt.info -x gnat_ug_wnt.texi -x gnat_ug_wnt.info-1 -x gnat_ug_wnt.info-2 -x gnat_ug_wnt.info-3 -x gnat-style.info -x gnat_rm.info -x autom4te.cache gcc-3.4.4-3-orig/gcc/testsuite/gcc.dg/i386-bitfield1.c gcc-3.4.4-3/gcc/testsuite/gcc.dg/i386-bitfield1.c
--- gcc-3.4.4-3-orig/gcc/testsuite/gcc.dg/i386-bitfield1.c	2002-12-16 18:22:44.000000000 +0000
+++ gcc-3.4.4-3/gcc/testsuite/gcc.dg/i386-bitfield1.c	2006-05-13 17:35:36.000000000 +0100
@@ -1,7 +1,7 @@
 // Test for bitfield alignment in structs on IA-32
 // { dg-do run { target i?86-*-* } }
 // { dg-options "-O2" }
-// { dg-options "-mno-align-double -mno-ms-bitfields" { target *-*-interix* } }
+// { dg-options "-mno-align-double -mno-ms-bitfields" { target *-*-interix* i?86-pc-mingw* i?86-pc-cygwin } }
 
 extern void abort (void);
 extern void exit (int);
